<?php


abstract class BaseTransportes extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $descripcion;

	
	protected $collDestinosComisionadoss;

	
	protected $lastDestinosComisionadosCriteria = null;

	
	protected $collComisionadosPlantas;

	
	protected $lastComisionadosPlantaCriteria = null;

	
	protected $collComisionadosContratos;

	
	protected $lastComisionadosContratoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescripcion()
	{

		return $this->descripcion;
	}

	
	public function setId($v)
	{

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = TransportesPeer::ID;
		}

	} 
	
	public function setDescripcion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->descripcion !== $v) {
			$this->descripcion = $v;
			$this->modifiedColumns[] = TransportesPeer::DESCRIPCION;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getFloat($startcol + 0);

			$this->descripcion = $rs->getString($startcol + 1);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Transportes object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TransportesPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			TransportesPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TransportesPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TransportesPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += TransportesPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collDestinosComisionadoss !== null) {
				foreach($this->collDestinosComisionadoss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collComisionadosPlantas !== null) {
				foreach($this->collComisionadosPlantas as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collComisionadosContratos !== null) {
				foreach($this->collComisionadosContratos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = TransportesPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collDestinosComisionadoss !== null) {
					foreach($this->collDestinosComisionadoss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collComisionadosPlantas !== null) {
					foreach($this->collComisionadosPlantas as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collComisionadosContratos !== null) {
					foreach($this->collComisionadosContratos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TransportesPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescripcion();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TransportesPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescripcion(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TransportesPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescripcion($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TransportesPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescripcion($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(TransportesPeer::DATABASE_NAME);

		if ($this->isColumnModified(TransportesPeer::ID)) $criteria->add(TransportesPeer::ID, $this->id);
		if ($this->isColumnModified(TransportesPeer::DESCRIPCION)) $criteria->add(TransportesPeer::DESCRIPCION, $this->descripcion);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(TransportesPeer::DATABASE_NAME);

		$criteria->add(TransportesPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescripcion($this->descripcion);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getDestinosComisionadoss() as $relObj) {
				$copyObj->addDestinosComisionados($relObj->copy($deepCopy));
			}

			foreach($this->getComisionadosPlantas() as $relObj) {
				$copyObj->addComisionadosPlanta($relObj->copy($deepCopy));
			}

			foreach($this->getComisionadosContratos() as $relObj) {
				$copyObj->addComisionadosContrato($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TransportesPeer();
		}
		return self::$peer;
	}

	
	public function initDestinosComisionadoss()
	{
		if ($this->collDestinosComisionadoss === null) {
			$this->collDestinosComisionadoss = array();
		}
	}

	
	public function getDestinosComisionadoss($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDestinosComisionadoss === null) {
			if ($this->isNew()) {
			   $this->collDestinosComisionadoss = array();
			} else {

				$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

				DestinosComisionadosPeer::addSelectColumns($criteria);
				$this->collDestinosComisionadoss = DestinosComisionadosPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

				DestinosComisionadosPeer::addSelectColumns($criteria);
				if (!isset($this->lastDestinosComisionadosCriteria) || !$this->lastDestinosComisionadosCriteria->equals($criteria)) {
					$this->collDestinosComisionadoss = DestinosComisionadosPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDestinosComisionadosCriteria = $criteria;
		return $this->collDestinosComisionadoss;
	}

	
	public function countDestinosComisionadoss($criteria = null, $distinct = false, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

		return DestinosComisionadosPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addDestinosComisionados(DestinosComisionados $l)
	{
		$this->collDestinosComisionadoss[] = $l;
		$l->setTransportes($this);
	}


	
	public function getDestinosComisionadossJoinTerceros($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDestinosComisionadoss === null) {
			if ($this->isNew()) {
				$this->collDestinosComisionadoss = array();
			} else {

				$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

				$this->collDestinosComisionadoss = DestinosComisionadosPeer::doSelectJoinTerceros($criteria, $con);
			}
		} else {
									
			$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastDestinosComisionadosCriteria) || !$this->lastDestinosComisionadosCriteria->equals($criteria)) {
				$this->collDestinosComisionadoss = DestinosComisionadosPeer::doSelectJoinTerceros($criteria, $con);
			}
		}
		$this->lastDestinosComisionadosCriteria = $criteria;

		return $this->collDestinosComisionadoss;
	}


	
	public function getDestinosComisionadossJoinMunicipios($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDestinosComisionadoss === null) {
			if ($this->isNew()) {
				$this->collDestinosComisionadoss = array();
			} else {

				$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

				$this->collDestinosComisionadoss = DestinosComisionadosPeer::doSelectJoinMunicipios($criteria, $con);
			}
		} else {
									
			$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastDestinosComisionadosCriteria) || !$this->lastDestinosComisionadosCriteria->equals($criteria)) {
				$this->collDestinosComisionadoss = DestinosComisionadosPeer::doSelectJoinMunicipios($criteria, $con);
			}
		}
		$this->lastDestinosComisionadosCriteria = $criteria;

		return $this->collDestinosComisionadoss;
	}


	
	public function getDestinosComisionadossJoinComisiones($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDestinosComisionadoss === null) {
			if ($this->isNew()) {
				$this->collDestinosComisionadoss = array();
			} else {

				$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

				$this->collDestinosComisionadoss = DestinosComisionadosPeer::doSelectJoinComisiones($criteria, $con);
			}
		} else {
									
			$criteria->add(DestinosComisionadosPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastDestinosComisionadosCriteria) || !$this->lastDestinosComisionadosCriteria->equals($criteria)) {
				$this->collDestinosComisionadoss = DestinosComisionadosPeer::doSelectJoinComisiones($criteria, $con);
			}
		}
		$this->lastDestinosComisionadosCriteria = $criteria;

		return $this->collDestinosComisionadoss;
	}

	
	public function initComisionadosPlantas()
	{
		if ($this->collComisionadosPlantas === null) {
			$this->collComisionadosPlantas = array();
		}
	}

	
	public function getComisionadosPlantas($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionadosPlantas === null) {
			if ($this->isNew()) {
			   $this->collComisionadosPlantas = array();
			} else {

				$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

				ComisionadosPlantaPeer::addSelectColumns($criteria);
				$this->collComisionadosPlantas = ComisionadosPlantaPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

				ComisionadosPlantaPeer::addSelectColumns($criteria);
				if (!isset($this->lastComisionadosPlantaCriteria) || !$this->lastComisionadosPlantaCriteria->equals($criteria)) {
					$this->collComisionadosPlantas = ComisionadosPlantaPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastComisionadosPlantaCriteria = $criteria;
		return $this->collComisionadosPlantas;
	}

	
	public function countComisionadosPlantas($criteria = null, $distinct = false, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

		return ComisionadosPlantaPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addComisionadosPlanta(ComisionadosPlanta $l)
	{
		$this->collComisionadosPlantas[] = $l;
		$l->setTransportes($this);
	}


	
	public function getComisionadosPlantasJoinTerceros($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionadosPlantas === null) {
			if ($this->isNew()) {
				$this->collComisionadosPlantas = array();
			} else {

				$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

				$this->collComisionadosPlantas = ComisionadosPlantaPeer::doSelectJoinTerceros($criteria, $con);
			}
		} else {
									
			$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastComisionadosPlantaCriteria) || !$this->lastComisionadosPlantaCriteria->equals($criteria)) {
				$this->collComisionadosPlantas = ComisionadosPlantaPeer::doSelectJoinTerceros($criteria, $con);
			}
		}
		$this->lastComisionadosPlantaCriteria = $criteria;

		return $this->collComisionadosPlantas;
	}


	
	public function getComisionadosPlantasJoinRegionales($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionadosPlantas === null) {
			if ($this->isNew()) {
				$this->collComisionadosPlantas = array();
			} else {

				$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

				$this->collComisionadosPlantas = ComisionadosPlantaPeer::doSelectJoinRegionales($criteria, $con);
			}
		} else {
									
			$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastComisionadosPlantaCriteria) || !$this->lastComisionadosPlantaCriteria->equals($criteria)) {
				$this->collComisionadosPlantas = ComisionadosPlantaPeer::doSelectJoinRegionales($criteria, $con);
			}
		}
		$this->lastComisionadosPlantaCriteria = $criteria;

		return $this->collComisionadosPlantas;
	}


	
	public function getComisionadosPlantasJoinComisiones($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionadosPlantas === null) {
			if ($this->isNew()) {
				$this->collComisionadosPlantas = array();
			} else {

				$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

				$this->collComisionadosPlantas = ComisionadosPlantaPeer::doSelectJoinComisiones($criteria, $con);
			}
		} else {
									
			$criteria->add(ComisionadosPlantaPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastComisionadosPlantaCriteria) || !$this->lastComisionadosPlantaCriteria->equals($criteria)) {
				$this->collComisionadosPlantas = ComisionadosPlantaPeer::doSelectJoinComisiones($criteria, $con);
			}
		}
		$this->lastComisionadosPlantaCriteria = $criteria;

		return $this->collComisionadosPlantas;
	}

	
	public function initComisionadosContratos()
	{
		if ($this->collComisionadosContratos === null) {
			$this->collComisionadosContratos = array();
		}
	}

	
	public function getComisionadosContratos($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionadosContratos === null) {
			if ($this->isNew()) {
			   $this->collComisionadosContratos = array();
			} else {

				$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

				ComisionadosContratoPeer::addSelectColumns($criteria);
				$this->collComisionadosContratos = ComisionadosContratoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

				ComisionadosContratoPeer::addSelectColumns($criteria);
				if (!isset($this->lastComisionadosContratoCriteria) || !$this->lastComisionadosContratoCriteria->equals($criteria)) {
					$this->collComisionadosContratos = ComisionadosContratoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastComisionadosContratoCriteria = $criteria;
		return $this->collComisionadosContratos;
	}

	
	public function countComisionadosContratos($criteria = null, $distinct = false, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

		return ComisionadosContratoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addComisionadosContrato(ComisionadosContrato $l)
	{
		$this->collComisionadosContratos[] = $l;
		$l->setTransportes($this);
	}


	
	public function getComisionadosContratosJoinTerceros($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionadosContratos === null) {
			if ($this->isNew()) {
				$this->collComisionadosContratos = array();
			} else {

				$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

				$this->collComisionadosContratos = ComisionadosContratoPeer::doSelectJoinTerceros($criteria, $con);
			}
		} else {
									
			$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastComisionadosContratoCriteria) || !$this->lastComisionadosContratoCriteria->equals($criteria)) {
				$this->collComisionadosContratos = ComisionadosContratoPeer::doSelectJoinTerceros($criteria, $con);
			}
		}
		$this->lastComisionadosContratoCriteria = $criteria;

		return $this->collComisionadosContratos;
	}


	
	public function getComisionadosContratosJoinRegionales($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionadosContratos === null) {
			if ($this->isNew()) {
				$this->collComisionadosContratos = array();
			} else {

				$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

				$this->collComisionadosContratos = ComisionadosContratoPeer::doSelectJoinRegionales($criteria, $con);
			}
		} else {
									
			$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastComisionadosContratoCriteria) || !$this->lastComisionadosContratoCriteria->equals($criteria)) {
				$this->collComisionadosContratos = ComisionadosContratoPeer::doSelectJoinRegionales($criteria, $con);
			}
		}
		$this->lastComisionadosContratoCriteria = $criteria;

		return $this->collComisionadosContratos;
	}


	
	public function getComisionadosContratosJoinComisiones($criteria = null, $con = null)
	{
				if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionadosContratos === null) {
			if ($this->isNew()) {
				$this->collComisionadosContratos = array();
			} else {

				$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

				$this->collComisionadosContratos = ComisionadosContratoPeer::doSelectJoinComisiones($criteria, $con);
			}
		} else {
									
			$criteria->add(ComisionadosContratoPeer::ID_TRANSPORTE, $this->getId());

			if (!isset($this->lastComisionadosContratoCriteria) || !$this->lastComisionadosContratoCriteria->equals($criteria)) {
				$this->collComisionadosContratos = ComisionadosContratoPeer::doSelectJoinComisiones($criteria, $con);
			}
		}
		$this->lastComisionadosContratoCriteria = $criteria;

		return $this->collComisionadosContratos;
	}

} 